var currentPage = ''
var viewportScale = 1

window.onscroll = function() {
    var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
    var center = scrollTop + window.innerHeight / 2;

    console.log('scrollTop: ' + scrollTop + ', center: ' + center);

    var pages = document.getElementsByClassName('page');
    var target;

    for (var i = 0, len = pages.length; i < len; i++) {
        var page = pages[i]
        var top = page.offsetTop;
        var bottom = top + (page.height || page.clientHeight);

        if ((top <= center) && (center <= bottom)) {
            target = page;
            break;
        }
    }
    if (target && currentPage != target.id) {
        currentPage = target.id;
        location.href = 'mage-viewer://page_changed?current_page=' + target.id;
    }
}

function setPageImage(pageId, src) {
    document.getElementById(pageId).src = src;
}

function onBodyClicked(event) {
    var ignoreIds = ['ad', 'support', 'favorite', 'next', 'share', 'community'];
    for (var i = 0, len = ignoreIds.length; i < len; i++) {
        if (ignoreIds[i] == event.target.id) return
    }

    var classes = event.target.classList;
    for (var i = 0, len = classes.length; i < len; i++) {
        if (classes[i] == 'ad_button') return
    }

    location.href = 'mage-viewer://body_clicked';
}

function onSupportClicked() {
    // TODO: 応援時の表示処理はあとで実装

    location.href = 'mage-viewer://support_clicked';
}

function onAdClicked(id) {
    location.href = 'mage-viewer://ad_clicked?id=' + id;
}

function onFavoriteClicked() {
    location.href = 'mage-viewer://favorite_clicked';
}

function onNextClicked() {
    location.href = 'mage-viewer://next_clicked';
}

function onShareClicked() {
    location.href = 'mage-viewer://share_clicked';
}

function onCommunityClicked() {
    location.href = 'mage-viewer://community_clicked';
}

window.onload = function() {
    addClickEvent(document.body, onBodyClicked);
    addClickEvent(document.getElementById('support'), onSupportClicked);
    addClickEvent(document.getElementById('favorite'), onFavoriteClicked);
    addClickEvent(document.getElementById('next'), onNextClicked);
    addClickEvent(document.getElementById('share'), onShareClicked);
    addClickEvent(document.getElementById('community'), onCommunityClicked);
}

function addClickEvent(element, listener) {
    if (!element) {
        return;
    }

    element.addEventListener('click', listener);
}

function addElementClass(id, className) {
    var element = document.getElementById(id);

    element.classList.add(className)
}

